package Extensions
{
	import mx.controls.Alert;
	
	import Actions.CActExtension;
	
	import Application.CRunApp;
	
	import Conditions.CCndExtension;
	
	import Events.CEvent;
	import Events.CEventProgram;
	import Events.CQualToOiList;
	
	import Expressions.CValue;
	
	import Objects.CObject;
	
	import Params.PARAM_OBJECT;
	
	import RunLoop.CCreateObjectInfo;
	import RunLoop.CObjInfo;
	import RunLoop.CRun;
	
	import Services.CArrayList;
	import Services.CBinaryFile;
	
	public class CRunForEach extends CRunExtension
	{
		private static var CON_ONFOREACHLOOPSTRING:int = 0;
		private static var CON_FOREACHLOOPISPAUSED:int = 1;
		private static var CON_OBJECTISPARTOFLOOP:int = 2;
		private static var CON_OBJECTISPARTOFGROUP:int = 3;
		private static var CON_ONFOREACHLOOPOBJECT:int = 4;
		private static var CON_LAST:int = 5;
		private static var ACT_STARTFOREACHLOOPFOROBJECT:int = 0;
		private static var ACT_PAUSEFOREACHLOOP:int = 1;
		private static var ACT_RESUMEFOREACHLOOP:int = 2;
		private static var ACT_SETFOREACHLOOPITERATION:int = 3;
		private static var ACT_STARTFOREACHLOOPFORGROUP:int = 4;
		private static var ACT_ADDOBJECTTOGROUP:int = 5;
		private static var ACT_ADDFIXEDTOGROUP:int = 6;
		private static var ACT_REMOVEOBJECTFROMGROUP:int = 7;
		private static var ACT_REMOVEFIXEDFROMGROUP:int = 8;
		private static var EXP_LOOPFV:int = 0;
		private static var EXP_LOOPITERATION:int = 1;
		private static var EXP_LOOPMAXITERATION:int = 2;
		private static var EXP_GROUPSIZE:int = 3;

		public var name:String;
		public var fvs:CArrayList;
		public var loopIndex:int;
		public var loopMax:int;
		public var paused:Boolean;
		public var forEachLoops:Array; // Name => ForEachLoop lookup
		public var pausedLoops:Array; // Name => Paused ForEachLoop lookup
		public var groups:Array;// Groupname => CArrayList of objects
		public var currentForEach:CRunForEachLoop;
		public var currentGroup:String;
		public var currentLooped:CObject;
		
		//Variables for the ObjectSelection framework to access
		public var populateLoop:CRunForEachLoop; //To fill with all currently selected objects
		public var partOfLoop:CRunForEachLoop; //To access the loop in question
		public var partOfGroup:CArrayList; //To access the group in question
		public var oiToCheck:int;	

		private var rhPtr:CRunApp;
		private var run:CRun;
		private var eventProgram:CEventProgram;
		private var ObjectList:Array;				//get a pointer to the mmf object list
		private var OiList:Array;						//get a pointer to the mmf object info list
		private var QualToOiList:Array;	//get a pointer to the mmf qualifier to Oi list

		private var rdPtr:Object;
		private var OiList2:int;
		private var negate:Boolean;
		private var filter:Function;
		
		public function CRunForEach()
		{
		}
		public override function getNumberOfConditions():int
	    {
	        return CON_LAST;
	    }
	    public override function createRunObject(file:CBinaryFile, cob:CCreateObjectInfo, version:int):Boolean
	    {
			this.currentGroup = null;
			
			this.forEachLoops = new Array();
			this.pausedLoops = new Array();
			this.groups = new Array();

			this.rhPtr=this.rh.rhApp;
			this.run= this.rhPtr.run;
			this.eventProgram= this.run.rhEvtProg;
			this.ObjectList= this.run.rhObjectList;				//get a pointer to the mmf object list
			this.OiList= this.run.rhOiList;						//get a pointer to the mmf object info list
			this.QualToOiList= this.eventProgram.qualToOiList;	//get a pointer to the mmf qualifier to Oi list
			
			return true;
	    }
		
		public override function condition(num:int, cnd:CCndExtension):Boolean
		{
			switch (num)
			{
				case CON_ONFOREACHLOOPSTRING:
					return cnd.getParamExpString(this.rh, 0)==this.currentForEach.name;
					
				case CON_FOREACHLOOPISPAUSED:
				{
					var loop:CRunForEachLoop = this.forEachLoops[cnd.getParamExpString(this.rh, 0)];
					return loop != null && loop.paused == true;
				}
					
				case CON_OBJECTISPARTOFLOOP:
				{
					var param:int = (PARAM_OBJECT(cnd.evtParams[0])).oiList;
					
					if ((partOfLoop = this.forEachLoops[cnd.getParamExpString (this.rh, 1)]) == null)
						return false;

					rdPtr= this;
					OiList2= param;
					negate= (cnd.evtFlags2 & CEvent.EVFLAG2_NOT) != 0;
					filter=this.filterPartOfLoop;
					return this.filterTheObjects();
				}
					
				case CON_OBJECTISPARTOFGROUP:
				{
					var param2:int = (PARAM_OBJECT(cnd.evtParams[0])).oiList;
					
					if ((this.partOfGroup = this.groups[cnd.getParamExpString(this.rh, 1)]) == null)
						return false;
					
					rdPtr= this;
					OiList2= param2;
					negate= (cnd.evtFlags2 & CEvent.EVFLAG2_NOT) != 0;
					filter=this.filterPartOfGroup;
					return this.filterTheObjects();
				}
					
				case CON_ONFOREACHLOOPOBJECT:
					
					if(this.currentForEach != null && cnd.getParamExpString(this.rh, 0)==this.currentForEach.name)
					{
						this.selectOneObject(this.currentLooped);
						return true;
					}
					
					return false;
			}
			
			return false;
		}
		
		public override function action(num:int, act:CActExtension):void
		{
			var loop:CRunForEachLoop;
			var group:CArrayList;
			var groupName:String;
			var loopName:String;
			var oi:int, fixed:int;
			switch (num)
			{
				case ACT_STARTFOREACHLOOPFOROBJECT:
				{
					loopName= act.getParamExpString (this.rh, 0);
					oi=(PARAM_OBJECT(act.evtParams[1])).oiList;                
					
					loop= new CRunForEachLoop ();
					this.populateLoop = loop;
					
					//Populate the current foreachloop with all the fixed values of the currently selected objects
					rdPtr= this;
					OiList2= oi;
					negate= false;
					filter=filterGetSelected;
					this.filterTheObjects();

					loop.name = loopName;
					loop.loopMax = loop.fvs.size();
					
					this.executeForEachLoop (loop);
				
					break;
				}
				case ACT_PAUSEFOREACHLOOP:
				{
					loop= this.forEachLoops[act.getParamExpString (this.rh, 0)];
					if(loop != null){
						loop.paused = true;
					}
					break;
				}
				case ACT_RESUMEFOREACHLOOP:
				{
					loopName= act.getParamExpString (this.rh, 0);
					loop= this.forEachLoops[loopName];
					if(loop != null)
					{
						loop.paused = false;
						this.pausedLoops.splice(loopName, 1);
						this.executeForEachLoop(loop);
					}
					break;
				}
				case ACT_SETFOREACHLOOPITERATION:
				{
					loop= this.forEachLoops[act.getParamExpString(this.rh, 0)];
					if(loop != null)
					{
						loop.loopIndex = act.getParamExpression(this.rh, 1);
					}
					break;
				}
				case ACT_STARTFOREACHLOOPFORGROUP:
				{
					loopName= act.getParamExpString (this.rh, 0);
					group= this.groups[act.getParamExpString (this.rh, 1)];
					if(group != null)
					{
						loop = new CRunForEachLoop ();
						loop.name = loopName;
						loop.loopMax = group.size();
						var i:int;
						for(i=0; i<group.size(); i++)
						{
							if (group.get(i)!=null)
							{
								loop.fvs.add(group);
							}
						}
						this.executeForEachLoop (loop);
					}
					break;
				}
				case ACT_ADDOBJECTTOGROUP:
				{
					if(this.ho.hoAdRunHeader.rhEvtProg.rh2ActionLoopCount != 0)
						return;
					
					oi=act.evtParams[0].oiList;                
					this.currentGroup = act.getParamExpString (this.rh, 1);
					group= this.groups[this.currentGroup];
					
					//Create group if it doesn't exist
					if(group == null)
					{
						group = new CArrayList();
						this.groups[currentGroup]=group;
					}
					
					rdPtr= this;
					OiList2= oi;
					negate= false;
					filter=filter;
					this.filterTheObjects();

					this.currentGroup = null;					
					break;
				}
				case CRunForEach.ACT_ADDFIXEDTOGROUP:
				{
					fixed= act.getParamExpression (this.rh, 0);
					groupName= act.getParamExpString (this.rh, 1);
					group= this.groups[groupName];
					
					if(fixed == 0)
						break;
					
					//Create group if it doesn't exist
					if(group == null)
					{
						group = new CArrayList();
						this.groups[groupName]=group;
					}
					
					group.add(fixed);
					break;
				}
				case CRunForEach.ACT_REMOVEOBJECTFROMGROUP:
				{
					var object:CObject = act.getParamObject (this.rh, 0);
					var id:int=(object.hoCreationId<<16)|((int(object.hoNumber))&0xFFFF);
					groupName= act.getParamExpString (this.rh, 1);
					group= this.groups[groupName];
					
					if(group == null || object == null)
						break;
					
					group.removeObject(id);
					
					//Delete group if empty
					if(group.size() == 0)
						this.groups.splice(groupName, 1);
					
					break;
				}
				case CRunForEach.ACT_REMOVEFIXEDFROMGROUP:
				{
					fixed= act.getParamExpression (this.rh, 0);
					groupName= act.getParamExpString (this.rh, 1);
					group= this.groups[groupName];
					
					if(group == null || fixed == 0)
						break;
					
					group.removeObject (fixed);
					
					//Delete group if empty
					if(group.size() == 0)
						this.groups.splice(groupName, 1);
					
					break;
				}
			}
		}
		
		public function executeForEachLoop(loop:CRunForEachLoop):void
		{
			//Store current loop
			var prevLoop:CRunForEachLoop = this.currentForEach;
			this.forEachLoops[loop.name]=loop;
			this.currentForEach = loop;
			for(;loop.loopIndex < loop.loopMax; ++loop.loopIndex)
			{
				//Was the loop paused?
				if(loop.paused)
				{
					//Move the fastloop to the 'paused' table
					this.pausedLoops[loop.name]=loop;
					this.forEachLoops.splice(loop.name, 1);
					break;
				}
				this.ho.generateEvent (CRunForEach.CON_ONFOREACHLOOPSTRING, 0);
				
				this.currentLooped = this.ho.getObjectFromFixed(int(loop.fvs.get (loop.loopIndex)));
				if(this.currentLooped != null)
					this.ho.generateEvent (CRunForEach.CON_ONFOREACHLOOPOBJECT, 0);
			}
			//Release the loop?
			if(!loop.paused)
				this.forEachLoops.splice(loop.name, 1);
			
			//Restore the previous loop (in case of nested loops)
			this.currentForEach = prevLoop;
		}
		
		public override function expression(num:int):CValue
		{
			var loop:CRunForEachLoop;
			var ret:CValue=new CValue(0);
			switch(num)
			{
				case EXP_LOOPFV:
				{
					loop= this.forEachLoops[this.ho.getExpParam().getString()];
					if(loop == null)
						break;
					ret.forceInt(int(loop.fvs.get(loop.loopIndex)));
					break;
				}
				case EXP_LOOPITERATION:
				{
					loop= this.forEachLoops[this.ho.getExpParam().getString()];
					if(loop == null)
						break;
					ret.forceInt(loop.loopIndex);
					break;
				}
				case EXP_LOOPMAXITERATION:
				{
					loop= this.forEachLoops[this.ho.getExpParam().getString()];
					if(loop == null)
						break;
					ret.forceInt(loop.loopMax);
					break;
				}
				case CRunForEach.EXP_GROUPSIZE:
				{
					var group:CArrayList = this.groups[this.ho.getExpParam().getInt()];
					if(group == null)
						break;
					ret.forceInt(group.size());
					break;
				}
			}
			return ret;
		}    
		
		public function filterPartOfLoop(rdPtr:CRunForEach, object:CObject):Boolean
		{
			var id:int=(object.hoCreationId<<16)|((int(object.hoNumber))&0xFFFF);
			return rdPtr.partOfLoop.fvs.contains(id);
		}
		
		public function filterPartOfGroup(rdPtr:CRunForEach, object:CObject):Boolean
		{
			var id:int=(object.hoCreationId<<16)|((int(object.hoNumber))&0xFFFF);
			return rdPtr.partOfGroup.contains(id);
		}
		//Adds all selected objects to the list of fixed values
		
		public function filterGetSelectedForGroup(rdPtr:CRunForEach, object:CObject):Boolean
		{
			var foreach:CRunForEach = rdPtr;
			var array:CArrayList = foreach.groups[foreach.currentGroup];
			var currentFixed:int = (object.hoCreationId<<16)|((int(object.hoNumber))&0xFFFF);
			
			if(array != null)
			{
				var i:int;
				for(i = 0; i < array.size(); ++ i)
				{
					var fixedInArray:int = int(array.get(i));
					
					if(currentFixed == fixedInArray)
						return true;
				}
				array.add(currentFixed);
			}
			return true; //Don't filter out any objects
		}
		
		//Adds all selected objects to the current group
		public function filterGetSelected(rdPtr:CRunForEach, object:CObject):Boolean
		{
			rdPtr.populateLoop.addObject(object);
			return true; 
		}
/*		
		//Run a custom filter on the SOL (via function callback)
		public function filterObjects(rdPtr:Object, OiList:int, negate:Boolean, filter:Function):Boolean
		{		
			if ((OiList & 0x8000) != 0)
			{
				return ((this.filterQualifierObjects(rdPtr, OiList & 0x7FFF, negate, filter) ? 1 : 0) ^ (negate ? 1 : 0)) != 0;
			}
			return ((this.filterNonQualifierObjects(rdPtr, OiList, negate, filter) ? 1 : 0) ^ (negate ? 1 : 0)) != 0;
		}
*/		

		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		// FLASH BUGS AVOIDANCE
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		//////////////////////////////////////////////////////////////////////////////////////////////////////////
		
		public function selectAll():void
		{
			var pObjectInfo:CObjInfo = this.OiList[OiList2];
			pObjectInfo.oilNumOfSelected = pObjectInfo.oilNObjects;
			pObjectInfo.oilListSelected = pObjectInfo.oilObject;
			pObjectInfo.oilEventCount = this.eventProgram.rh2EventCount;
			
			var i:int = pObjectInfo.oilObject;
			while(i>=0)
			{
				var pObject:CObject = this.ObjectList[i];
				pObject.hoNextSelected = pObject.hoNumNext;
				i = pObject.hoNumNext;
			}
		}
		
		//Filter qualifier objects
		public function filterTheObjects():Boolean
		{
			if ((OiList2 & 0x8000) != 0)
			{
				OiList2&=0x7FFF;
				return ((this.filterQualifierObjects() ? 1 : 0) ^ (negate ? 1 : 0)) != 0;
			}
			return ((this.filterNonQualifierObjects() ? 1 : 0) ^ (negate ? 1 : 0)) != 0;
		}
		
		public function filterQualifierObjects():Boolean
		{
			var CurrentQualToOi:CQualToOiList = this.QualToOiList[OiList2];
			
			var hasSelected:Boolean = false;
			var i:int = 0;
			
			while(i<CurrentQualToOi.qoiList.length)
			{
				OiList2 = CurrentQualToOi.qoiList[i+1];
				hasSelected = (((hasSelected ? 1 : 0) |
					(this.filterNonQualifierObjects() ? 1 : 0))) != 0;				
				i+=2;
			}
			return hasSelected;
		}
		
		//Filter normal objects
		public function filterNonQualifierObjects():Boolean
		{
			var pObjectInfo:CObjInfo = this.OiList[OiList2];
			if(pObjectInfo == null)
				return false;
			var hasSelected:Boolean = false;
			if (pObjectInfo.oilEventCount != this.eventProgram.rh2EventCount)
			{
				this.selectAll();	//The SOL is invalid, must reset.
			}
			
			//If SOL is empty
			if(pObjectInfo.oilNumOfSelected <= 0)
			{
				return false;
			}
			
			var firstSelected:int = -1;
			var count:int = 0;
			var current:int = pObjectInfo.oilListSelected;
			var previous:CObject = null;
			
			while(current>=0)
			{
				var pObject:CObject = this.ObjectList[current];
				var filterResult:Boolean = filter(rdPtr, pObject);
				
				var useObject:Boolean = ((filterResult ? 1 : 0) ^ (negate ? 1 : 0)) != 0;
				hasSelected = ((hasSelected ? 1 : 0) | (useObject ? 1 : 0)) != 0;
				
				if(useObject)
				{
					if(firstSelected == -1)
					{
						firstSelected = current;
					}
					
					if(previous != null)
					{
						previous.hoNextSelected = current;
					}
					
					previous = pObject;
					count++;
				}
				current = pObject.hoNextSelected;
			}
			if(previous != null)
			{
				previous.hoNextSelected = -1;
			}
			
			pObjectInfo.oilListSelected = firstSelected;
			pObjectInfo.oilNumOfSelected = count;
			
			return hasSelected;
		}

		public function selectOneObject(object:CObject):void
		{
			var pObjectInfo:CObjInfo = object.hoOiList;
			pObjectInfo.oilNumOfSelected = 1;
			pObjectInfo.oilEventCount = this.eventProgram.rh2EventCount;
			pObjectInfo.oilListSelected = object.hoNumber;
			this.ObjectList[object.hoNumber].hoNextSelected = -1;
		}
		
	}
}